/* Android PhotoTrap application
   RemoteGuard 2019
*/

'use strict';

// Logging utility function.
function trace(arg) {
 // var now = (window.performance.now() / 1000).toFixed(3);

//  console.log('webview ' //+now
//   + ': ' + arg);
}

var localConnection;
var remoteConnection;
var localChannel;
var receiveChannel;
var receiveLocalChannel;
var receiveRemoteChannel;
var remoteChannel;

var pcConstraint;
var dataConstraint;
var remote_descr;
var remote_descr2;
var remote_desc;
var re_desc;
var local_des;

var localStream;
var remoteStream;
var localVideoTracks;
var localAudioTracks;

var recorder; 
var a; 
var videorecords = [];
var captures = [];

var pc1;
var pc2;
var pc3;
var offerOptions = {
  offerToReceiveAudio: true,
  offerToReceiveVideo: true
};   

var localVideo = document.getElementById('localVideo');
var remoteVideo = document.getElementById('remoteVideo');
var connecting = document.getElementById('connecting');

var start = true;

var pc_config;
																
var Android;
var startTime;

var who;

// каждая сторона содержит массивы sdp_offer и sdp_answer:
var data_sdp_offer =[]; // массив элементов sdp data-channel
var data_sdp_offer_url; // промежуточный
var data_sdp_answer; 

pcConstraint = null;
dataConstraint = null;

localVideo.addEventListener('loadedmetadata', function() {
  trace('Local video videoWidth: ' + this.videoWidth +
    'px,  videoHeight: ' + this.videoHeight + 'px');
});

remoteVideo.addEventListener('loadedmetadata', function() {
  trace('Remote video videoWidth: ' + this.videoWidth +
    'px,  videoHeight: ' + this.videoHeight + 'px');
});

remoteVideo.onresize = function() {
  trace('Remote video size changed to ' +
    remoteVideo.videoWidth + 'x' + remoteVideo.videoHeight);
  // We'll use the first onsize callback as an indication that video has started
  // playing out.
  if (startTime) {
    var elapsedTime = window.performance.now() - startTime;
    trace('Setup time: ' + elapsedTime.toFixed(3) + 'ms');
    startTime = null;
  }
};

function whoAmI () {
 
if(location.search.substring(1).charAt(0) === 'C') {
                    who = 'caller';
					connecting.style.display = 'block'; 
					document.getElementById("remoteVideo").style.display = "block";

					startlocalvideo();
                 } 

if (location.search.substring(1).charAt(0) === 'l') { 
      who = 'callee';      
      startlocalvideo();
  } 
}

// начало
whoAmI();

function getName(pc) {
    if (pc ===pc1) return 'pc1';
    if (pc ===pc2) return 'pc2';
    if (pc ===pc3) return 'pc3';
    if (pc ===localConnection) return 'localConnection';
    if (pc === remoteConnection) return 'remoteConnection';
}

function getOtherPc(pc) {
  return (pc === pc1) ? pc2 : pc1;
}

// создание локального потока
function gotStream(stream) {
//Android.trace('Received local stream');
  localVideo.srcObject = stream;
  trace('stream added to localVideo');
  window.localStream = stream;
//trace('local stream is available');
  startTime = window.performance.now();
  window.localVideoTracks = localStream.getVideoTracks();
  window.localAudioTracks = localStream.getAudioTracks();
  if (localVideoTracks.length > 0) {
    trace('Using video device: ' + localVideoTracks[0].label);
  }
  if (localAudioTracks.length > 0) {
      trace('Using audio device: ' + localAudioTracks[0].label + localAudioTracks[0].enabled);
  }

  start = true;

  connecting.style.display = 'block';

  var param = location.search.substring(2).split(",");

    try {
       trace ("server = "+param[2]);
       trace ("username = "+param[3]);
       trace ("credential = "+param[4]);

      if (param[2] === 'disabled'){
             pc_config = {iceTransportPolicy:"all", // "relay" to force turn
                                       "iceServers": [
        						 	    { "url": "stun:stun.l.google.com:19302"},
        						        { "url": "stun:stun1.l.google.com:19302"},
        								{ "url": "stun:stun2.l.google.com:19302"},
        								{ "url": "stun:stun3.l.google.com:19302"},
        								{ "url": "stun:stun4.l.google.com:19302"}
        								]};

      } else {
  	          pc_config = {iceTransportPolicy:"all", // "relay" to force turn
                                 "iceServers": [{"url": "turn:"+param[2],
                                                 "username": param[3],
                                                 "credential": param[4]},
  						 	     { "url": "stun:stun.l.google.com:19302"}
  						//		{ "url": "stun:stun1.l.google.com:19302"},
  						//		{ "url": "stun:stun2.l.google.com:19302"},
  						//		{ "url": "stun:stun3.l.google.com:19302"},
  						//		{ "url": "stun:stun4.l.google.com:19302"}
  								]};
  								}

    } catch(error){};

  if (who==='caller')  iAmCaller();
  if (who ==='callee') Android.iAmCallee();
}

function receiveLocalChannelCallbackData(event) {
  trace('Receive Data Channel Callback');
  receiveLocalChannel = event.channel;
  receiveLocalChannel.onmessage = onLocalReceiveMessageCallbackData;
  receiveLocalChannel.onopen = onReceiveChannelStateChangeData(receiveLocalChannel);
  receiveLocalChannel.onclose = onReceiveChannelStateChangeData(receiveLocalChannel);
}
function receiveRemoteChannelCallbackData(event) {
  trace('Receive Data Channel Callback');
  receiveRemoteChannel = event.channel;
  receiveRemoteChannel.onmessage = onRemoteReceiveMessageCallbackData;
  receiveRemoteChannel.onopen = onReceiveChannelStateChangeData(receiveRemoteChannel);
  receiveRemoteChannel.onclose = onReceiveChannelStateChangeData(receiveRemoteChannel);
}
function onLocalReceiveMessageCallbackData(event) {
  trace('Received Message from remote');
  var data = event.data;
  gettingAnswer(data);  
}
      
function onRemoteReceiveMessageCallbackData(event) {
  trace('Received Message from local');
  var data = event.data;
  //
  createAnswer(data);  
}

function onReceiveChannelStateChangeData(receiveChannel) {
  var readyState = receiveChannel.readyState;
  trace('Receive Data channel state is: ' + readyState);
}

var des;
function gotDescriptionLocalConnection(desc) {
  des = desc;
  localConnection.setLocalDescription(desc); 
 /*  pc1.createOffer(
       offerOptions   // параметры SDP (audio & video)
  ).then(function (desc0) {
        onCreateOfferSuccess_0 (pc1, desc0); // здесь запускается сбор кандидатов
    },
    onCreateSessionDescriptionError
  );
  */
}
function senddataanswer (){  
    remoteConnection.setRemoteDescription(des);
    remoteConnection.createAnswer().then(
    gotDescription2,
    onCreateSessionDescriptionError
  );    
}

function gotDescription2(desc) {    
remoteConnection.setLocalDescription(desc);  // сбор кандидатов не запускается, поэтому исп-ся pc3.createOffer
trace ('remoteConnection set localDescription');
trace('remoteConnection signaling state = ' + remoteConnection.signalingState);
trace ('remoteChannel 1 ' + remoteChannel.readyState);

//alert ('remoteConnection localDescription: ' + remoteConnection.remoteDescription.sdp);

/*pc3.createOffer(       // только для запуска сбора кандидатов на своей стороне
    offerOptions   // параметры SDP (audio & video)
  ).then(function (desc0) {
        onCreateOfferSuccess_0 (pc3, desc0);
    },
    onCreateSessionDescriptionError
  );
  */
}

function closeDataChannels() {
  trace('Closing data channels');
  localChannel.close();
 // trace('Closed data channel with label: ' + localChannel.label);
  receiveChannel.close();
 // trace('Closed data channel with label: ' + receiveChannel.label);
  localConnection.close();
  remoteConnection.close();
  localConnection = null;
  remoteConnection = null;
 // trace('Closed peer connections');

}

// активация камеры и микрофона, получение локального потока
function startlocalvideo() {
  trace('Requesting local stream');
   navigator.mediaDevices.getUserMedia ({audio: true, video: {
 //   width:{exact:320}, height:{exact:240},
    facingMode: { exact: "environment" } }
   })
            .then(gotStream)
            .catch(function(e) {
  //  alert('getUserMedia() error: ' + e);
             trace ("getUserMedia error "+e);
            });
}

function iAmCaller() {
    document.getElementById("remoteVideo").style.display = "block";

// создание объекта RTCpeerconnection для caller-a
   pc1 = new RTCPeerConnection(pc_config);//, , pcConstraint);
 
   trace('pc1 created, default IceServers : '+ pc1.defaultIceServers);
   
   pc1.onicecandidate = function(e) {  // добавление обработчика 
    onIceCandidate(pc1, e);
   }; 
   pc1.onicegatheringstatechange = function (){
     trace ('pc1 ICE gathering state: '+pc1.iceGatheringState);
    // trace ('pc2 ICE gathering state: '+pc2.iceGatheringState);
  };
  pc1.oniceconnectionstatechange = function(e) {
    onIceStateChange(pc1, e);
  };

  pc1.addStream(localStream);

/*try{
    for (const track of localStream.getTracks()) {
       pc1.addTrack(track);
       trace('pc1 add track '+track.label);
    };
} catch (error){
     //  pc1.addTrack(localVideoTracks[0], localStream);
}
*/

 pc1.ontrack = function(event){
          gotRemoteStream(event);
       }


 /* if (pc1.addTrack){
   for (const track of localStream.getTracks()) {
     pc1.addTrack(track);
   };
    pc1.ontrack = function(event){
         gotRemoteStream(event);
   //  trace('Received remote track');
   //  window.remoteStream = event.streams[0];
   //  remoteVideo.srcObject = event.streams[0];

     }
  } else {
      pc1.addStream(localStream);
      pc1.onaddstream = gotRemoteStream;
      }
*/
  //trace('pc1 initial signalingState: ' + pc1.signalingState);
  
 // pc1.onaddstream = gotRemoteStream;


  // создание pc для data channel
  localConnection = new RTCPeerConnection(pc_config, pcConstraint);
  trace('Created localconnection');

     localChannel = localConnection.createDataChannel('sendDataChannel', dataConstraint);
     localChannel.onopen =  onLocalChannelStateChange; 
     localChannel.onclose = onLocalChannelStateChange; 
 localConnection.ondatachannel = receiveLocalChannelCallbackData;

   localConnection.onicecandidate = function(e) {  // добавление обработчика
      onIceCandidate(localConnection, e);
     };

  // запуск
  localConnection.createOffer().then( // запускается сбор кандидатов
    gotDescriptionLocalConnection,
    onCreateSessionDescriptionError
  );   
  Android.connLog("startIceCollection");
}

function onLocalChannelStateChange() {
  var readyState = localChannel.readyState;
  trace('local Data channel state is: ' + readyState);
  if (readyState === 'open') {
    pc1.createOffer(
         {offerToReceiveVideo: true}   // параметры SDP (audio & video)
    ).then(function (desc0) {
          onCreateOfferSuccess_0 (pc1, desc0); // здесь запускается сбор кандидатов
      },
      onCreateSessionDescriptionError
    );

  //trace ('pc1 offer sent via data channel: '+pc1.localDescription.sdp);
  trace ('pc1 offer creation started');

  } else {
//    dataChannelSend.disabled = true;
//    sendButtonData.disabled = true;
//    closeButtonData.disabled = true;
  }
}
 
  function onSendChannelStateChangeData() {
//      if (channel = )
  var readyState = localChannel.readyState;
  //trace('Send Data channel state is: ' + readyState);
  if (readyState === 'open') {
      // отправляем данные по дата-ченнелу
   // sendData(data);
  } else {
  }
}

function sendData(channel, data) {
  if (channel === "local") localChannel.send(data);
  if (channel === "remote") remoteChannel.send(data);
  //trace('Sent Data: ' + data);
}


function iAmCallee(data_sdp_offer) {
    
   document.getElementById("localVideo").style.display = "block";
    
   data_sdp_offer = data_sdp_offer.split(";").join("\r\n"); // восстановление формата sdp
   trace('Receiving call');
  
  // создание объекта RTCPeerConnection для callee
  pc2 = new RTCPeerConnection(pc_config);
  //Android.trace('Created remote peer connection object pc2');
      
  pc2.onicecandidate = function(e) {
    onIceCandidate(pc2, e);
  };  
  pc2.oniceconnectionstatechange = function(e) {
    onIceStateChange(pc2, e);
  };
 
  pc2.addStream(localStream);
 /* try {
      for (const track of localStream.getTracks()) {
         pc2.addTrack(track);
         trace('pc2 add track '+track.label);
      };
  } catch (error){
     //    pc2.addTrack(localVideoTracks[0], localStream); // если не поддерживается множественное добавление видео-треков
  }
  */

  // pc2.addTrack(localVideoTracks[0], localStream);
// приём потока от другой стороны. onaddstream вызывается при поступлении потока от другой стороны.
 // pc2.onaddstream = gotRemoteStream;  // на Хроме нужно устанавливать этот обработчик ДО отправки offer???
  
//  createDataConnection();
remoteConnection = new RTCPeerConnection(pc_config, pcConstraint);
 // Android.trace('Created remoteConnection');

remoteConnection.oniceconnectionstatechange = function(e) {
                                                  onIceStateChangeRemoteData(remoteConnection, e);
                                                  };;

     remoteConnection.ondatachannel = receiveRemoteChannelCallbackData;
     remoteChannel = remoteConnection.createDataChannel('sendDataChannel2', dataConstraint);
     remoteChannel.onopen = onRemoteChannelStateChange;
     remoteChannel.onclose = onRemoteChannelStateChange;// ('remote', null);
     
remote_desc = new RTCSessionDescription();
remote_desc.type = "offer";
//Android.trace ('data_sdp_offer: ' + data_sdp_offer);
remote_desc.sdp  = data_sdp_offer; // restoreOfferSDP(data_sdp_offer);
remoteConnection.setRemoteDescription(remote_desc);
remoteConnection.onicecandidate = function(e) {  // добавление обработчика
      onIceCandidate(remoteConnection, e);
     };
remoteConnection.createAnswer().then(
    gotDescription2,
    onCreateSessionDescriptionError
  );   
}

function onRemoteChannelStateChange() {
  var readyState = remoteChannel.readyState;
  trace('remoteData channel state is: ' + readyState);
  if (readyState === 'open') {    
 //   sendData ('remote', pc2.localDescription.sdp); // отправляем sdp-answer
 //   trace('web: pc2 answer sent')
  } else {
//    dataChannelSend.disabled = true;
//    sendButtonData.disabled = true;
//    closeButtonData.disabled = true;
  }
}

function onCreateSessionDescriptionError(error) {
  trace('Failed to create session description: ' + error.toString());
}

// при успешном создании предварительного оффера
function onCreateOfferSuccess_0(pc, desc) {   // description содержит sdp offer 
 // trace('Offer from pc1\n' + desc.sdp); // вывод sdp в консоль. В SDP могут содержаться ice-кандидаты
 // trace('pc1 signalingState1: ' + pc1.signalingState);
//  trace('pc1 setLocalDescription_0 start');
  pc.setLocalDescription(desc).then(  // после установки local description начинается сбор (gathering) кандидатов
     function() {
      onSetLocalSuccess(pc);
    },
    onSetSessionDescriptionError
  );
}

// при успешном создании основного SDP offer-a
function onCreateOfferSuccess(desc) {   // description содержит sdp offer 
  trace('Offer from pc1\n' + desc.sdp); // вывод sdp в консоль. В SDP могут содержаться ice-кандидаты
 // trace('pc1 signalingState1: ' + pc1.signalingState);
  trace('pc1 setLocalDescription start');
  
   re_desc = new RTCSessionDescription();
                re_desc.type = "answer";
                re_desc.sdp =  " "; //restoreAnswerSDP(localStorage.getItem("answer")); //.split(",").join("\n");
	            pc1.setRemoteDescription(re_desc)
				.then(function(){
				pc1.setLocalDescription(desc).then(  // после установки local description начинается сбор (gathering) кандидатов   
    function() {
      onSetLocalSuccess(pc1);
    },
    onSetSessionDescriptionError
)
}, onSetSessionDescriptionError);
			//	.catch('failed to set remote description');
  

  
// при поступлении оффера от рс1  (через сигн.канал):
 
 // trace('pc2 setRemoteDescription start'); // remote pc2 сразу ставит desc local pc1 как remotedescription 
  
  pc2.setRemoteDescription(desc).then(
//    pc1.setRemoteDescription(desc).then( // поставим свой локал-дескрипшн как ремоут-дескр. Не работает!
    function() {
   //   trace('pc2 signalingState1: ' + pc2.signalingState);
      onSetRemoteSuccess(pc2);
    },
    onSetSessionDescriptionError
  );
}


// здесь можно отправить SDP offer другой стороне
function onSetLocalSuccess(pc) {
  trace(getName(pc) + ' setLocalDescription complete');
  trace(getName(pc)+' onSetLocalSuccess signalingState: ' + getName(pc).signalingState);
  pc.getStats(function(stats){
	  stats.result().forEach(function(report){	
	    report.names().forEach(function (name){
		//   trace ("report name: "+ name);  
		//   trace ("report: "+ report.stat(name));  
		    }) 
	   });	
  });
}

function onSetRemoteSuccess(pc) {
  trace(getName(pc) + ' setRemoteDescription complete');
  trace(getName(pc) + ' onSetRemoteSuccess signalingState: ' + getName(pc).signalingState);
  pc.getStats(function(stats){
	  stats.result().forEach(function(report){	
	    report.names().forEach(function (name){
	    //   trace ("report name: "+ name);  
		//   trace ("report: "+ report.stat(name));  
		    }) 
	   });	
  });
}

function onSetSessionDescriptionError(error) {
  trace('Failed to set session description: ' + error.toString());
}

function gotRemoteStream(e) {
  window.remoteStream = e.streams[0];

  remoteVideo.srcObject = remoteStream;

  Android.gotStream();
 // if (localAudioTracks[0]) remoteVideo.muted = false;

  document.getElementById("connecting").style.display = "none";
  
 /* try {
     var param = location.search.substring(2).split(",");
//  trace ("audio = "+param[0].substring(6));
//  trace ("video = "+param[1].substring(6));
    if (param[0].substring(6) == "true") toggleaudio(true);
        else toggleaudio(false);
    if (param[1].substring(6) == "true") togglevideo(true);
        else togglevideo(false);
    Android.gotStream();
    } catch(error){trace('I am not a caller');}
    */

    trace('Received remote stream');
}

function toggleControls(show) {
    if (show){
            remoteVideo.classList.add('video-show-controls');
    } else {
            remoteVideo.classList.remove('video-show-controls');
    }
}

function onCreateAnswerSuccess(desc) {
//  trace('Answer from pc2:\n' + desc.sdp);
 // trace('pc2 setLocalDescription start');
//  trace('pc2 onCreateAnswerSuccess signalingState: ' + pc2.signalingState);
  pc2.setLocalDescription(desc).then(
    function() {
      onSetLocalSuccess(pc2);
    },
    onSetSessionDescriptionError
  );
//  trace('pc1 setRemoteDescription start');
  pc1.setRemoteDescription(desc).then(
//      pc2.setRemoteDescription(desc).then(  // ставим свой локал дескрипшн как ремоут-дескр. Не работает!
    function() {
      onSetRemoteSuccess(pc1);
    },
    onSetSessionDescriptionError
  );
}

function onCreateAnswerSuccess0(desc) {
//  trace('Answer from pc2:\n' + desc.sdp);
//  trace('pc2 setLocalDescription start');
// trace('Create pc2 answer');
 pc2.setLocalDescription(desc).then(  // начинается сбор кандидатов
    function() {
      onSetLocalSuccess(pc2);
    },
    onSetSessionDescriptionError
  );
}

// обработчик события добавления ICE-кандидата в объект RTCPeerConnection
// событие возникает, когда ICE-агент нашел ice-кандидата для своей pc
function onIceCandidate(pc, event) {
    
   if (event.candidate) {
  // Android.trace(getName(pc) + ' new ICE candidate: \n' + event.candidate.candidate);
   if (pc === pc1) {
 //  localConnection.addIceCandidate(event.candidate).catch(e=>{trace('failure during add ICE candidate '+e.name)});
       // trace ('localConnection Ice candidate' + localConnection.signalingState);
   }
  /* if (pc === pc3) {
      remoteConnection.addIceCandidate(event.candidate).catch(e=>{trace('failure during add ICE candidate '+e.name)});
                   pc2.addIceCandidate(event.candidate).catch(e=>{trace('failure during add ICE candidate '+e.name)});
   }
   */
  }

   if (pc === localConnection && event.candidate === null){ // сбор кандидатов закончен
   trace ('web: localConnection candidate gathering finished, sending localConnection SDP');
          data_sdp_offer = localConnection.localDescription.sdp; //fillSDParray (localConnection.localDescription.sdp);
          sendSMS(data_sdp_offer, null); // отправляем оффер дата-ченнел
    }

  if (pc === pc1 && event.candidate === null){ // сбор кандидатов закончен
 // alert (localConnection.localDescription.sdp);
     //   data_sdp_offer = localConnection.localDescription.sdp; //fillSDParray (localConnection.localDescription.sdp);
     //   sendSMS(data_sdp_offer, null); // отправляем оффер дата-ченнел
     trace('pc1 sdp = '+ pc1.localDescription.sdp);
        sendData ('local', pc1.localDescription.sdp); // отправляем sdp-offer
  }

 if (pc === remoteConnection && event.candidate === null){ // сбор кандидатов закончен
        data_sdp_answer = remoteConnection.localDescription.sdp; //fillSDParray (remoteConnection.localDescription.sdp);
       // Android.trace ('remoteChannel 2 ' + remoteChannel.readyState);
   //     pc3.close();
   //     pc3 = null;
        sendSMS(null, data_sdp_answer);
// alert ("sdp_answer = " + data_sdp_answer);    
   }
 if (pc === pc2 && event.candidate === null){ // сбор кандидатов закончен
        trace ('pc2 sdp = '+pc2.localDescription.sdp);
        sendData ('remote', pc2.localDescription.sdp);
       // trace ('pc2 answer sent');
// alert ("sdp_answer = " + data_sdp_answer);    
   }
}

function sendSMS(offer_sdp, answer_sdp){
 //  Android.trace('offer = '+ offer_sdp+" answer = "+answer_sdp);  
 if (answer_sdp === null) {
    Android.sendSDP(offer_sdp);
}
   if (offer_sdp === null) { // reply with answer form callee
    Android.sendSDP(answer_sdp);
	}
}

function gottenAnswer (answer){  // вызывается из Андроид
     answer = answer.split(";").join("\r\n");
   //  Android.trace(answer);
     re_desc = new RTCSessionDescription();
                re_desc.type = "answer";
                re_desc.sdp =  answer; //restoreAnswerSDP(localStorage.getItem("answer")); //.split(",").join("\n");
     try {localConnection.setRemoteDescription(re_desc); } catch(error){trace('answer before offer')}; 
           //  Android.trace('localConnection signaling state  = ' + localConnection.signalingState);
         //   trace ('localConnection remoteDescription set');  
}

function createAnswer (data){
//  pc2.setRemoteDescription(JSON.parse(dataChannelReceive.value))
//desc.type = "offer";
//desc.sdp = dataChannelReceive.value;
remote_descr = new RTCSessionDescription();
remote_descr.type = "offer"; 
remote_descr.sdp  = data;
  pc2.setRemoteDescription(remote_descr)
          .then(
    function() {
     onSetRemoteSuccess(pc2);
    },
    onSetSessionDescriptionError
  );   
  // создаём начальный ансфер для запуска сбора кандидатов, но не отправляем его
    trace('pc2 createAnswer start');
  // Since the 'remote' side has no media stream we need
  // to pass in the right constraints in order for it to
  // accept the incoming offer of audio and video.
    pc2.createAnswer({offerToReceiveVideo: true}).then(
    onCreateAnswerSuccess0,
    onCreateSessionDescriptionError
  );

}

function gettingAnswer (data){
     
//  trace('sending answer'); // т.е. отправляется pc2.localDescription
remote_descr2 = new RTCSessionDescription();
remote_descr2.type = "answer";
remote_descr2.sdp  = data;
  pc1.setRemoteDescription(remote_descr2).then(
    function() {
     onSetRemoteSuccess(pc1);
    },
    onSetSessionDescriptionError
  );  
}

function onAddIceCandidateSuccess(pc) {
  trace(getName(pc) + ' addIceCandidate success');
}

function onAddIceCandidateError(pc, error) {
  trace(getName(pc) + ' failed to add ICE Candidate: ' + error.toString());
}

function onIceStateChange(pc, event) {
  if (pc) {
  //  Android.trace(getName(pc) + ' ICE state: ' + pc.iceConnectionState);
  //  trace('ICE state change event: ' + event);
	trace('ICE state change event: ' + getName(pc)+pc.iceConnectionState  + event.toString());
	if(pc.iceConnectionState === "connected" || pc.iceConnectionState === "completed") document.getElementById("connecting").style.display = "none";
     else document.getElementById("connecting").style.display = "block";
    if (pc.iceConnectionState === "failed") {
        if (whoAmI==='caller') Android.connLog("pcfailed");
         else //       if (whoAmI==="callee")
             hangup();
    }
  }
}

function onIceStateChangeLocalData(pc, event) {
  if (pc) {
  //  Android.trace('LocalConnection ICE state: ' + localConnection.iceConnectionState);
//   trace('RemoteData' + ' ICE state: ' + remoteConnection.iceConnectionState);
 //   trace('ICE state change event: ' + event);
  trace('ICE state change localData event: ' + getName(pc)+pc.iceConnectionState);
  }
}

function onIceStateChangeRemoteData(pc, event) {
  if (pc) {
   // Android.trace('RemoteData' + ' ICE state: ' + pc.iceConnectionState);
   // trace('ICE state change event: ' + event);
	trace('ICE state change remoteData event: ' + getName(pc)+pc.iceConnectionState);
	if (pc.iceConnectionState == "failed") hangup();
  }
}

function hangup() {    
  trace('Ending call');
  document.getElementById("connecting").style.display = "none";
try {
  if (who === "caller"){
     pc1.close(); 
     pc1 = null;
     localConnection.close();
     localConnection = null;      
     }
  if (who === "callee") {
     pc2.close(); 
     pc2 = null;
     remoteConnection.close();
     remoteConnection = null;
     }     
    Android.sendSDP("hangup");
  /*  var r;
    if (captures.length > 0 || videorecords.length > 0){
    if (captures.length > 0 && videorecords.length === 0)  r = confirm('You have ' + captures.length + ' captures\nPress Ok to view captures or Cancel to delete them');
    if (captures.length === 0 && videorecords.length > 0) r = confirm('You have ' + videorecords.length + ' video records\nPress Ok to view records or Cancel to delete them');
    if (captures.length > 0 && videorecords.length > 0)  r = confirm('You have ' + captures.length + ' captures and ' + videorecords.length + ' video records\nPress Ok to view records or Cancel to delete them');
    if (r){
    for (var i = 0; i < captures.length; i++) {
         window.open(captures[i]) ;
        }   
    for (var i = 0; i < videorecords.length; i++) {
         window.open(videorecords[i]) ;
        }
     }  
  }
  */
}
catch (error){
       trace ("hangup error "+error);
          }
finally {
 //   hangupButton.disabled = true;
 //   recordButton.disabled = true;
    
    if (localStream) {
     localStream.getAudioTracks().forEach(function(track) {
            track.stop();
        });
     localStream.getVideoTracks().forEach(function(track) {
            track.stop();
        });
    // localStream.stop(); �� ��������
     localStream = null; 
	 trace ("local stream closed");
    } 
     
     if (remoteStream) {
     remoteStream.getAudioTracks().forEach(function(track) {
            track.stop();
        });
     remoteStream.getVideoTracks().forEach(function(track) {
            track.stop();
        });
   //  remoteStream.stop();   �� ��������
     remoteStream = null;
	 trace ("remote stream closed");
    }
   // window.close();
     Android.closeWindow();
}
}
           
            
function takePicture(){
    
var canvas = document.querySelector('canvas');
canvas.setAttribute('width', 640);
canvas.setAttribute('height', 480);
var ctx = canvas.getContext('2d');
//ctx.drawImage(remoteVideo, 0, 0);
ctx.drawImage(remoteVideo, 0, 0);
    // "image/webp" works in Chrome 18. In other browsers, this will fall back to image/png.
		var takenBlob = canvas.toBlob(function (takenBlob){
			var reader = new window.FileReader();
            reader.readAsDataURL(takenBlob);
	     	reader.onloadend = function(){
			var string64 = reader.result;
		//	trace("string64 = "+string64);
			Android.saveBlob (string64, false);
		    }
		} , 'image/webp', 1 );

}            
            
            
function recordVideo (startRecord){
    if (startRecord){
  //  recorder = new MediaRecorder(stream);
    recorder = null;
    recorder = new MediaRecorder(remoteStream, {mimeType:'video/webm' }); 
    var data = [];
    recorder.addEventListener('dataavailable', function (e){  // вызывается при recorder.stop(); 
              data.push(e.data);
              var recordedBlob = new Blob(data, { type: "video/webm" });
    
      //  var url = window.URL.createObjectURL(recordedBlob);
	//	trace ('recorded size = '+recordedBlob.size);
	//	trace ('recorded video url: ' + url);
	    
		
		var reader = new window.FileReader();
        reader.readAsDataURL(recordedBlob);
		reader.onloadend = function(){
			var string64 = reader.result;
		//	trace("string64 = "+string64);
			Android.saveBlob (string64, true);
		}
		data.length = 0; // очистка массива
		//recordedBlob = null;
		// не работает в webview:
	/*	var a = document.createElement("a");
		document.body.appendChild (a);
		a.style = "display:none";
		a.href = url;
		a.download = "recordedvideo.webm"; 
		a.click();
		window.URL.revokeObjectURL(url);
		*/
           } 
        );  
        trace('start video recording');		
        recorder.start(30000); // 30 секунд
        start = false;
		
    } else {
        trace('stop video recording');
        recorder.stop();
        start = true;    
        		
    }    
}

//var audio;
function toggleaudio(audio){
	if (audio){
		remoteStream.getAudioTracks().forEach(function(track){
			track.enabled = true;
		trace('audio toggle on');
		});
	} else {
		remoteStream.getAudioTracks().forEach(function(track){
			track.enabled = false;
	    trace('audio toggle off');

		});
	}
	
} 
//var video;     
function togglevideo(video){
	if (video){
		remoteStream.getVideoTracks().forEach(function(track){
			track.enabled = true;
		});		
	} else {
		remoteStream.getVideoTracks().forEach(function(track){
			track.enabled = false;
		});
	}
}  
            
            
            
            
            
            
           
                       
